<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__hal__dac" kind="group">
    <compoundname>group_hal_dac</compoundname>
    <title>DAC (Digital to Analog Converter)</title>
    <innergroup refid="group__group__hal__results__dac">DAC HAL Results</innergroup>
      <sectiondef kind="enum">
      <memberdef id="group__group__hal__dac_1gab8bd602f1b7d91eacd4126873148e5a3" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_dac_ref_t</name>
        <enumvalue id="group__group__hal__dac_1ggab8bd602f1b7d91eacd4126873148e5a3aa38d2cb249af9c70780d9b6aaa225e24" prot="public">
          <name>CYHAL_DAC_REF_VDDA</name>
          <briefdescription>
<para>Analog supply (default) </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__dac_1ggab8bd602f1b7d91eacd4126873148e5a3af87f660f3058a173c6fbdeb24528e46f" prot="public">
          <name>CYHAL_DAC_REF_VREF</name>
          <briefdescription>
<para>Internal reference. See the BSP documentation for the reference value. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_dac_ref_t: </bold><linebreak />Reference choices for the DAC.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="101" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dac.h" bodystart="97" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dac.h" line="98" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__dac_1gaa33e893eccc66deff01287434a847687" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_dac_init</definition>
        <argsstring>(cyhal_dac_t *obj, cyhal_gpio_t pin)</argsstring>
        <name>cyhal_dac_init</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dac__t">cyhal_dac_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>pin</declname>
        </param>
        <briefdescription>
<para>Initialize the DAC peripheral. </para>        </briefdescription>
        <detaileddescription>
<para>By default, the reference will be set to <ref kindref="member" refid="group__group__hal__dac_1ggab8bd602f1b7d91eacd4126873148e5a3aa38d2cb249af9c70780d9b6aaa225e24">CYHAL_DAC_REF_VDDA</ref>.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a DAC object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pin</parametername>
</parameternamelist>
<parameterdescription>
<para>The dac pin name </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request. On success returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>.<linebreak />
 On failure, a problem specific error code will be returned. This error could be from the HAL or lower level driver. <linebreak />
 For all other return codes, please refer to device driver documentation available in the BSP landing page </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dac.h" line="115" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dac_1gae157cda193ce7fc45eb5b390e40d0d0b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_dac_free</definition>
        <argsstring>(cyhal_dac_t *obj)</argsstring>
        <name>cyhal_dac_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dac__t">cyhal_dac_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Release the dac object. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The dac object </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dac.h" line="121" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dac_1ga0fd4a8c9b2b5e3b712904d3e63ed8a41" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_dac_set_reference</definition>
        <argsstring>(cyhal_dac_t *obj, cyhal_dac_ref_t ref)</argsstring>
        <name>cyhal_dac_set_reference</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dac__t">cyhal_dac_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__dac_1gab8bd602f1b7d91eacd4126873148e5a3">cyhal_dac_ref_t</ref></type>
          <declname>ref</declname>
        </param>
        <briefdescription>
<para>Set the DAC voltage reference. </para>        </briefdescription>
        <detaileddescription>
<para>This determines the highest value that the DAC can output.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The DAC object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>ref</parametername>
</parameternamelist>
<parameterdescription>
<para>The selected voltage reference. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the reference selection request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dac.h" line="129" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dac_1gabb6bdec361f3805b7086cef3ea3b9d56" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_dac_write</definition>
        <argsstring>(const cyhal_dac_t *obj, uint16_t value)</argsstring>
        <name>cyhal_dac_write</name>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__dac__t">cyhal_dac_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>value</declname>
        </param>
        <briefdescription>
<para>Set the output voltage, as a normalized unsigned 16-bit value (where 0 is the lowest value the DAC can output and 0xFFFF is the highest) </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;While the input value is 16 bits, the actual resolution that can be achieved is dependent on what the underlying hardware supports. See the device datasheet for details.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The dac object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">value</parametername>
</parameternamelist>
<parameterdescription>
<para>The 16-bit output value to set </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dac.h" line="141" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dac_1ga1f3c2d83b1d94abc0c77bc55379459bb" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_dac_write_mv</definition>
        <argsstring>(const cyhal_dac_t *obj, uint16_t value)</argsstring>
        <name>cyhal_dac_write_mv</name>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__dac__t">cyhal_dac_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint16_t</type>
          <declname>value</declname>
        </param>
        <briefdescription>
<para>Set the output voltage, as an unsigned number of millivolts. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Depending on the resolution of the underlying hardware, it may not be possible to achieve the precise voltage requested. See the device datasheet for more details about the DAC resolution.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;It is an error to specify a value that is outside of the DAC's operating range.</verbatim></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The dac object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">value</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of millivolts to output set. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the write request. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dac.h" line="155" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dac_1ga2ad162f2317e6f1666d7eadebbddca82" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint16_t</type>
        <definition>uint16_t cyhal_dac_read</definition>
        <argsstring>(cyhal_dac_t *obj)</argsstring>
        <name>cyhal_dac_read</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dac__t">cyhal_dac_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Read the current DAC output voltage setting, as a normalized unsigned 16-bit value (where 0 is the lowest value the DAC can output and 0xFFFF is the highest). </para>        </briefdescription>
        <detaileddescription>
<para>Note: Depending on the precision of the underlying hardware, this may not precisely match the most recent value passed in to cyhal_dac_write.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The dac object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The 16-bit output value </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dac.h" line="166" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__dac_1ga7a08830e80bd91017013c5f7cf306f0d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_dac_set_power</definition>
        <argsstring>(cyhal_dac_t *obj, cyhal_power_level_t power)</argsstring>
        <name>cyhal_dac_set_power</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__dac__t">cyhal_dac_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__general__types_1ga246fde0e79029f514ce3846b31e366d7">cyhal_power_level_t</ref></type>
          <declname>power</declname>
        </param>
        <briefdescription>
<para>Changes the current operating power level of the DAC. </para>        </briefdescription>
        <detaileddescription>
<para>If the power level is set to <ref kindref="member" refid="group__group__hal__general__types_1gga246fde0e79029f514ce3846b31e366d7a0f601c5d5843c59e58ee1988dd0e6861">CYHAL_POWER_LEVEL_OFF</ref>, the DAC will be powered-off but it will retain its configuration, so it is not necessary to reconfigure it when changing the power level from <ref kindref="member" refid="group__group__hal__general__types_1gga246fde0e79029f514ce3846b31e366d7a0f601c5d5843c59e58ee1988dd0e6861">CYHAL_POWER_LEVEL_OFF</ref> to any other value.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>dac object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">power</parametername>
</parameternamelist>
<parameterdescription>
<para>The power level to set </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set power request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_dac.h" line="178" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>High level interface for interacting with the digital to analog converter (DAC). </para>    </briefdescription>
    <detaileddescription>
<para>This block drives a pin with a firmware configurable voltage. See the device datasheet for details on which pins support DAC output.</para>
<para><heading level="1">Features</heading></para>
<para>The DAC driver provides APIs to:<itemizedlist>
<listitem><para>Configure and work with the DAC hardware</para></listitem><listitem><para>Update the DAC output value</para></listitem><listitem><para>Read the DAC output voltage setting</para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The &lt;a href="group__group__hal__dac.html#group__group__hal__dac_1gabb6bdec361f3805b7086cef3ea3b9d56"&gt;cyhal_dac_write&lt;/a&gt; and &lt;a href="group__group__hal__dac.html#group__group__hal__dac_1ga2ad162f2317e6f1666d7eadebbddca82"&gt;cyhal_dac_read&lt;/a&gt; APIs are defined as 16-bit, which may not match the underlying hardware. The functions will linearly scale the 16-bit value to and from a resolution that hardware is capable of outputting. For instance, if the device supports 12-bit resolution, only the 12 MSBs of the 16-bit value will be used. Refer to BSP Settings section in the kit's BSP API Reference Manual for details on the DAC's output range.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><heading level="1">Quick Start</heading></para>
<para>Call <ref kindref="member" refid="group__group__hal__dac_1gaa33e893eccc66deff01287434a847687">cyhal_dac_init</ref> to initialize a DAC instance by providing the DAC object ( <bold> obj </bold> ) and an output pin (<bold> pin </bold>).</para><para>See <ref kindref="member" refid="group__group__hal__dac_1subsection_dac_use_case_1">Use case 1: Simple DAC initialization</ref>.</para>

<para><heading level="1">Code Snippets</heading></para>

<para><bold>Use case 1: Simple DAC initialization</bold></para>
<para>The following snippet initializes a DAC resource and assigns the output to the specified <bold>pin</bold> using <ref kindref="member" refid="group__group__hal__dac_1gaa33e893eccc66deff01287434a847687">cyhal_dac_init</ref>. <ref kindref="member" refid="group__group__hal__dac_1gabb6bdec361f3805b7086cef3ea3b9d56">cyhal_dac_write</ref> is used to set the DAC output value. <ref kindref="member" refid="group__group__hal__dac_1ga2ad162f2317e6f1666d7eadebbddca82">cyhal_dac_read</ref> is used to read back DAC register. <programlisting filename="dac.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__dac__t">cyhal_dac_t</ref><sp />my_dac_obj;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />dac_result;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Full<sp />Scale<sp />value<sp />for<sp />the<sp />DAC<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />dac_value<sp />=<sp />0xFFFF;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint16_t<sp />dac_read;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />DAC,<sp />set<sp />Pin<sp />9[6]<sp />as<sp />the<sp />DAC<sp />output<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />dac_result<sp />=<sp /><ref kindref="member" refid="group__group__hal__dac_1gaa33e893eccc66deff01287434a847687">cyhal_dac_init</ref>(&amp;my_dac_obj,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__116__bga__ble_1ggaf78d7d92acc4005cc057d8a9b48e6f28aca42e6dc954ab8b8625f87b8e37f9bf2">P9_6</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />the<sp />return<sp />of<sp />cyhal_dac_init<sp />to<sp />confirm<sp />initialization<sp />was<sp />successful<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(dac_result<sp />==<sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Write<sp />the<sp />16<sp />bit<sp />value<sp />as<sp />DAC<sp />input<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__dac_1gabb6bdec361f3805b7086cef3ea3b9d56">cyhal_dac_write</ref>(&amp;my_dac_obj,<sp />dac_value);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Return<sp />the<sp />16<sp />bit<sp />DAC<sp />register<sp />value<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />dac_read<sp />=<sp /><ref kindref="member" refid="group__group__hal__dac_1ga2ad162f2317e6f1666d7eadebbddca82">cyhal_dac_read</ref>(&amp;my_dac_obj);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(dac_read<sp />==<sp />0xFFFF)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />code<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Release<sp />DAC<sp />object<sp />after<sp />use<sp />by<sp />calling<sp />cyhal_dac_free,<sp />this<sp />de-initializes<sp />the<sp />DAC<sp />(including<sp />its<sp />output)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting></para>

    </detaileddescription>
  </compounddef>
</doxygen>